///////////////////////////////////////////////////////////////////////////////
// Name:        nviz3d.h
// Purpose:     3D Visualization Header
// Author:      Chad Rempp
// Modified by:
// Created:     06-01-03
// Copyright:   (c) Chad Rempp 2003
// Licence:     GNU Public License
///////////////////////////////////////////////////////////////////////////////

#ifndef _NVIZ3D_H_
#define _NVIZ3D_H_

#include "wx/wx.h"
#include "wx/glcanvas.h"
#include "GL/glu.h"

// !!--TODO--!!
// Try to get rid of these.

GLfloat neuron_radius = 0.5;
int neuron_stacks = 10;
int neuron_slices = 10;

static float last_x = 0,
             last_y = 0;
static GLfloat camera_x = 0;
static GLfloat camera_y = 0;
static GLfloat camera_zoom = -6.0;
static GLfloat camera_rotate = 0.0;

GLfloat drag_scale_x = 0.05;
GLfloat drag_scale_y = 0.05;
GLfloat rotate_scale = 0.01;
GLfloat zoom_scale   = 0.05;

wxTextCtrl *txt_drag_scale_x;
wxTextCtrl *txt_drag_scale_y;

GLUquadricObj *gl_neuron_00 = gluNewQuadric();
GLUquadricObj *gl_neuron_01 = gluNewQuadric();
GLUquadricObj *gl_neuron_02 = gluNewQuadric();
GLUquadricObj *gl_neuron_03 = gluNewQuadric();
GLUquadricObj *gl_neuron_04 = gluNewQuadric();
GLUquadricObj *gl_neuron_05 = gluNewQuadric();

///////////////////////////////////////////////////////////////////////////////
//  NViz3DApp class Definition
///////////////////////////////////////////////////////////////////////////////
/*
class Nviz3DApp: public wxApp
{
public:
    bool OnInit(void);
};
*/

///////////////////////////////////////////////////////////////////////////////
//  NVizFrame class Definition
///////////////////////////////////////////////////////////////////////////////
class Nviz3DCanvas;
class NvizFrame: public wxFrame
{
public:
    NvizFrame(wxFrame *frame, const wxString& title, const wxPoint& pos,
              const wxSize& size, long style = wxDEFAULT_FRAME_STYLE);

    void OnExit(wxCommandEvent& event);
//    void OnSettings(wxCommandEvent &event);
    
public:
    Nviz3DCanvas*    glc_nvizcanvas;

DECLARE_EVENT_TABLE()
};

///////////////////////////////////////////////////////////////////////////////
//  NViz3DCanvas class Definition
///////////////////////////////////////////////////////////////////////////////
class Nviz3DCanvas: public wxGLCanvas
{
  friend class NVizFrame;
public:
    Nviz3DCanvas(wxWindow *parent, const wxWindowID id = -1,
                 const wxPoint& pos = wxDefaultPosition,
                 const wxSize& size = wxDefaultSize,
                 long style = 0, const wxString& name = "TestGLCanvas");
    ~Nviz3DCanvas(void);
    void DrawNeuron(GLUquadricObj *obj, GLfloat x, GLfloat y, GLfloat z);
    void InitGL(void);
    void OnEnterWindow( wxMouseEvent& event );
    void OnEraseBackground(wxEraseEvent& event);
    void OnMouse( wxMouseEvent& event );
    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void Render( void );

private:
    bool   m_init;

DECLARE_EVENT_TABLE()
};

///////////////////////////////////////////////////////////////////////////////
//  Menu Item enum
///////////////////////////////////////////////////////////////////////////////
/*enum
{
    SETTINGS
};
*/
#endif

